import { GraphQLFieldConfigArgumentMap, GraphQLFieldConfig, GraphQLFieldResolver } from "graphql";
import { TypeExpression, TypeArg } from "../type-expression/TypeExpression";
import { MetadataStorage } from "../base/MetadataStorage";
import { InputFieldReference } from "./InputField";
export interface FieldProps {
    description?: string;
    deprecationReason?: string;
    directives?: any;
    resolve?: Function;
}
export declare class FieldReference {
    name: string;
    field: Field;
    props: FieldProps;
    constructor(name: string, field: Field, props: FieldProps);
}
export interface FieldBuilder {
    output: TypeArg | TypeExpression;
    args: InputFieldReference[];
    buildResolver?(storage: MetadataStorage): GraphQLFieldResolver<any, any> | undefined;
    buildArgs?(storage: MetadataStorage): GraphQLFieldConfigArgumentMap;
    buildConfig?(storage: MetadataStorage): GraphQLFieldConfig<any, any>;
}
export declare class Field implements FieldBuilder {
    constructor(builder?: FieldBuilder);
    output: TypeExpression;
    args: InputFieldReference[];
    mountAs(fieldName: string, props?: FieldProps): FieldReference;
    buildResolver(storage: MetadataStorage): GraphQLFieldResolver<any, any> | undefined;
    buildArgs(storage: MetadataStorage): GraphQLFieldConfigArgumentMap;
    buildConfig(storage: MetadataStorage): GraphQLFieldConfig<any, any>;
}
