"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FieldReference = /** @class */ (function () {
    function FieldReference(name, field, props) {
        this.name = name;
        this.field = field;
        this.props = props;
    }
    return FieldReference;
}());
exports.FieldReference = FieldReference;
var Field = /** @class */ (function () {
    function Field(builder) {
        if (builder) {
            Object.assign(this, builder);
        }
    }
    Field.prototype.mountAs = function (fieldName, props) {
        return new FieldReference(fieldName, this, props || {});
    };
    Field.prototype.buildResolver = function (storage) {
        return;
    };
    Field.prototype.buildArgs = function (storage) {
        var args = this.args;
        return args.reduce(function (args, ref) {
            args[ref.name] = Object.assign(ref.field.buildConfig(storage), ref.props);
            return args;
        }, {});
    };
    Field.prototype.buildConfig = function (storage) {
        var output = this.output;
        return {
            type: output.buildTypeInstance(storage),
            args: this.buildArgs(storage),
            resolve: this.buildResolver(storage),
        };
    };
    return Field;
}());
exports.Field = Field;
//# sourceMappingURL=Field.js.map