import { GraphQLInputObjectType, GraphQLInputFieldConfigMap, GraphQLInputFieldConfig } from "graphql";
import { DefinitionMetadata, DefinitionMetadataConfig } from "../base/DefinitionMetadata";
import { MetadataStorage, InputFieldReferenceEntry } from "../base/MetadataStorage";
import { DefinitionClass } from "../types";
import { ASTParser } from "../sdl/ast";
export interface InputTypeConfig extends DefinitionMetadataConfig {
}
/**
 * Metadata type for InputObjectType
 */
export declare class InputType<T extends InputTypeConfig = InputTypeConfig> extends DefinitionMetadata<T> {
    protected static decorate(astParser: ASTParser, storage: MetadataStorage, definitionClass: DefinitionClass): void;
    buildInputFieldConfig(storage: MetadataStorage, definitionClass: DefinitionClass, entry: InputFieldReferenceEntry): GraphQLInputFieldConfig;
    buildInputFieldConfigMap(storage: MetadataStorage, definitionClass: DefinitionClass): GraphQLInputFieldConfigMap;
    buildTypeInstance(storage: MetadataStorage, definitionClass: DefinitionClass): GraphQLInputObjectType;
}
