"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var DefinitionMetadata_1 = require("../base/DefinitionMetadata");
/**
 * Metadata type for InputObjectType
 */
var InputType = /** @class */ (function (_super) {
    __extends(InputType, _super);
    function InputType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InputType.decorate = function (astParser, storage, definitionClass) {
        var _this = this;
        astParser.inputObjectTypeMetadataConfigs.forEach(function (config) {
            storage.register(new _this(config), definitionClass);
        });
        astParser.inputFieldMetadataConfigs.forEach(function (config) {
            storage.registerInputFieldReference(config, definitionClass);
        });
    };
    InputType.prototype.buildInputFieldConfig = function (storage, definitionClass, entry) {
        return Object.assign({}, entry.reference.field.buildConfig(storage), entry.reference.props);
    };
    InputType.prototype.buildInputFieldConfigMap = function (storage, definitionClass) {
        var _this = this;
        var inputFieldMetadata = storage.queryInputFieldReference(definitionClass);
        return inputFieldMetadata.reduce(function (results, entry) {
            results[entry.reference.name] = _this.buildInputFieldConfig(storage, definitionClass, entry);
            return results;
        }, {});
    };
    InputType.prototype.buildTypeInstance = function (storage, definitionClass) {
        var name = this.typeName;
        var fields = this.buildInputFieldConfigMap.bind(this, storage, definitionClass);
        var description = this.description;
        return new graphql_1.GraphQLInputObjectType({ name: name, fields: fields, description: description });
    };
    return InputType;
}(DefinitionMetadata_1.DefinitionMetadata));
exports.InputType = InputType;
//# sourceMappingURL=InputType.js.map