import { GraphQLFieldConfigMap, GraphQLTypeResolver, GraphQLInterfaceType, GraphQLFieldConfig } from "graphql";
import { DefinitionMetadata, DefinitionMetadataConfig } from "../base/DefinitionMetadata";
import { MetadataStorage, FieldReferenceEntry } from "../base/MetadataStorage";
import { DefinitionClass } from "../types";
import { ASTParser } from "../sdl/ast";
export interface InterfaceTypeConfig extends DefinitionMetadataConfig {
    resolveType?: GraphQLTypeResolver<any, any>;
    description?: string;
}
/**
 * Metadata type for InterfaceType
 */
export declare class InterfaceType<T extends InterfaceTypeConfig = InterfaceTypeConfig> extends DefinitionMetadata<T> {
    protected static decorate(astParser: ASTParser, storage: MetadataStorage, definitionClass: DefinitionClass): void;
    buildFieldConfig(storage: MetadataStorage, definitionClass: DefinitionClass, entry: FieldReferenceEntry): GraphQLFieldConfig<any, any>;
    buildFieldConfigMap(storage: MetadataStorage, definitionClass: DefinitionClass): GraphQLFieldConfigMap<any, any>;
    buildTypeInstance(storage: MetadataStorage, definitionClass: DefinitionClass): GraphQLInterfaceType;
}
