import { GraphQLType } from "graphql";
import { MetadataStorage, DefinitionMetadataEntry } from "../base/MetadataStorage";
import { Lazy } from "../types";
export declare type TypeArg = GraphQLType | string | Function;
/**
 * Contain an argument which can be resolved to GraphQLType instance.
 */
export declare class TypeExpression {
    protected options: TypeArg | Lazy<TypeArg>;
    constructor(typeArg: TypeArg | Lazy<TypeArg>);
    private getCompleteTypeArg;
    typeArg: TypeArg | Lazy<TypeArg>;
    getDefinitionMetadataEntry(storage: MetadataStorage): DefinitionMetadataEntry;
    buildTypeInstance(storage: MetadataStorage): GraphQLType;
}
